% corrdim test functions
% (c) Ruslan Enikeev http://profitengines.ru

clear
clc
close all

%line in one dimensional space
eps = 1.0001;
X = (1:1:10000)';

[x y] = corrdim(X, eps);

fracdim(x, y, 2, -5, 3, 1);
 
  
%line in two dimensional space

eps = 1.5;
X = (1:1:1000)';
X = [X X];

[x y] = corrdim(X, eps);

fracdim(x, y, 2, -5, 3, 1);
 

%line in two dimensional space with contant 3rd coordinate
eps = 1.5;
X = (1:1:1600)';
X = [X X ones(size(X))];

[x y] = corrdim(X, eps);

fracdim(x, y, 2, -5, 3, 1);

%line in two dimensional space with 3rd random coordinate
eps = 1.5;
X = (1:1:1600)';
X = [X X rand(size(X))*length(X)];

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 2, 7, 1);

%Cantor (0.631)
X = cantor(13,1);

eps = 0.01;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, -5, 3, 1);
 

% Koch (1.262)
X = koch(8,1);

eps = 0.01;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, -5, 3, 1);
 
 
%Sierpinski Gasket (1.585)
figure
X = sierpinski(256,1);

eps = 1.001;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 3, 7, 1);


% Sierpinski Carpet (1.893) 
figure
X = teppich(4,1);

eps = 1.001;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 2, 6, 1);
 

% uniform random
X = rand(10000, 10);

eps = 0.01;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 1, 3, 1);

% gaussian random
X = randn(10000, 10);

eps = 0.01;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 1, 3, 1);

% Henon attractor
a = 1.4;
b = -0.3;
x0(1,1) = -0.20285918082982;
x0(1,2) = -0.77046087278650;

X = eno(a, b, 10000, x0, 1);

eps = 0.01;

[x y] = corrdim(X, eps);

fracdim(x, y, 2, 1, 9, 1);
