function x = eno(a, b, cnt, x0, plotflag)

% x = eno(a, b, cnt, x0, plotflag)
% plot Henon attractor
% x(n+1) = 1 - a*x(n)^2 - b*y(n)
% y(n+1) = x(n)
%
% Arguments:
% a, b  - coefficients
% cnt   - number of iterations
% x0    - initial point (vector-row)
% plotflag  - plot 
% Returns:
% x     - orbit (matrix cnt+1  2)

if nargin < 5
    plotflag = 0;
end

x = x0;

for i=1:cnt
    x(i+1, 1) = 1 - a*x(i, 1)^2 - b*x(i, 2);
    x(i+1, 2) = x(i, 1);
end

if plotflag == 1
    plot(x(:,1), x(:,2), '.')   
end