% Determination of fractal dimension and noise level of the test set
% (c) Ruslan Enikeev http://profitengines.ru

close all
clc
clear

ptscnt = 3000;   %number of points
eps = 0.001;     %min edge of the hypercube
noise = 0.01;    %noise level

startang = 1*pi;
endang = 3.5*pi;

%set construction
step = (endang-startang)/(ptscnt-1);

angle = startang:step:endang;

ptscnt = length(angle);

Z = (1:1:ptscnt)/ptscnt*10;

m = Z;

X = [sin(angle).*m; cos(angle).*m; Z]';

%adding noise
X = X + randn(size(X))*noise;

plot3(X(:,1), X(:,2), X(:,3), '.')

grid on
xlim([-10 10])
ylim([-10 10])
zlim([0 10])

title('Test set')

%determine fractal dimension
[x y] = corrdim(X, eps);

fracdim(x, y, 2, 3, 5, 1);
fracdim(x, y, 2, 7, 12, 2);